;----------------------------------------------------------
;Title   : \܂ 48{PCG` for SHARP X1
;Version : Ver.2019.10.11
;Auther  : @superturboZ
;
;PsځA54̓eLXgg܂B
;	
;usage:
;	call	pcgx_setup    : PCGhCopɃeLXgVRAMB
;	call	pcgx_set_data : PCG`f[^\񂷂B
;	call	pcgx_update   : \񂵂PCG`sB
;
;spec:
;
;80x25sW𑜓xpAX1turbołX1pB
;X1turboœꍇ |[g1FD0H.bit5=0Ō݊PCG[hɂĂB
;G~[^ł͍͓̏ȂB
;
;X[p[C|[YOɂĂƒ`܂B
;tF[YH-interval̃xt@CłǁA
;
;note:
;
;CRTC/PCG ^C~O
;     : 4.0 / (14.31818 /8)   = 2.23492 CPU clks per CRTC char
;`Ԋu : INC B OUTI            = 20 clks , *2.23492 = 8.9488 char
;`   : (IOW.T2R-T4F)         = 2.5clks , *2.23492 = 1.1161 char
;
;PCG`peLXgVRAM zu
;|SYNC1|SYNC2|SYNC3|PCG0|PCG8|PCG1|PCG9|PCG2-7/A-F| N.U.||total|
;| 19  |  4  |  7  |  5 |  4 | 5  | 4  |(5+4)x6=54| 10  || 112 |
;|    48 (37D0-37FF)    |        64(3000-303F)          || 112 |
;
;V[PX
;SETUP
;
;UPDATE
;@E擪64oCgA/TVRAMPCGpɐݒ
;@EVBLANK Jn҂AVBLANK˓Ȃ玟̃t[Ŏs
;ROW 25 : 
;@ECRTC̕\0ɐݒ
;@ESYNCCG-ROM[hg SYNC1:2+-0.5 char xɓ
;ROW 26 : PCG.B ` CHR[0..7] x RASTER[0..7]
;ROW 27 : PCG.R ` CHR[0..7] x RASTER[0..7]
;ROW 28 : PCG.G ` CHR[0..7] x RASTER[0..7]
;ROW 29 : ESYNC2:3ɕύXAPCG.B ` CHR[8..F]
;ROW 30 : PCG.R ` CHR[8..F]
;ROW 31 : PCG.G ` CHR[8..F]
;ROW 32 : CRTC̕\80ɕ(2X^Ȃ̂Œ)

;----------------------------------------------------------
;}NƂ
;----------------------------------------------------------

NUM_PCG_CHR			equ	16	;Pt[Œ`łő吔̔AύXsB
PCG_LAYOUT_INTERACE	equ	1	;f[^z

;----------------------------------------------------------
	include	"wait.mac"

;----------------------------------------------------------
	include	"pcgx_setup_ns.asm"
	include	"pcgx_data_set.asm"
;----------------------------------------------------------

;----------------------------------------------------------
;PCG̒`s
;pcgx_data_set ŗ\񂵂PCG`܂
;
;in:
;out:
;	A : error code
;
;----------------------------------------------------------
pcgx_update:
;--------------------
pcg_retry:
;VDISPJn҂
vdisp_wait_l:
	ei
	ld	bc,1a01h
	nop
	di
	in	a,(c)
	jp	p,vdisp_wait_l
;PsڂVRAMPCGpɃZbgAbv
	ld	hl,d_fill_row0
	call	vram_fill
;setup OK
	ld	hl,b_pattern		;PCG pattern buffer
;sace system stack
	ld	(iw_pcgx_spp),sp
	ld	a,07h				;rlca
	ld	(ic_pcg_wr_sync_op),a
;VDISPă`FbN
	ld	bc,1a01h
	ld	e,1					;error code
	in	a,(c)				;VDISP
	jp	p,vdisp_error_join		;łVBLANK˓Ȃ烊gC
;VBLANK҂
vblank_wait_l:
	in	a,(c)				;-VBLANK
	jp	m,vblank_wait_l
;---- sync 25.0 ----
;10c (+22)
;CRTCOɐݒ
	ld	bc,1800h	;10
	ld	de,1*256 +0	;10
	out	(c),d		;12
	inc	c			; 4
	out	(c),e		;12 CRTC.R[1]=0
;48c
	ld	bc,1400h	;10 CG-ROM I/O
	ld	e,7			; 7 raster loop
;17c
	ld	a,9			; 7 wc 	
	dec	a
	jr	nz,$-1
;146c = 9*16+2
	ld	a,(hl)
	WAIT12C
;19c

;VBLANK  X1F/X1tZ@ł0.1-1.1L炢̒xŌoł炵B
;PCG-RAMpCvC̒xlĂQLȏVBALNKωQLxĎ荞ނ̂S
;250+4 -12(IN) = 242cœƍl΂悵H

;SYNC1̐͏\̂ŁAƒx点SB
	WAIT4C
	
;------------------------------------
;PX^SYNC1/SYNC2̃{[_[CG-ROMp^[ŕ߂܂B
;ǒ덷 -0+22 == }11 clock
sync22:
	in	a,(c)		;CG-ROM
;12c
;---- sync 25.1 : 254c (+22c) -----
	jp	p,sync22
;21c (+-11) == 10c+22c
	ld	a,12
	dec	a
	jr	nz,$-1
;194c = 12*16+2
	WAIT11C_A
	WAIT12C
;23c
;|CgTvŌ덷 6 clock k 덷}5ɕ␳
	in	a,(c)		;CG-ROM
;12c
;----- sync 25.2 : 250c (+-11c) -----
	jr	nz,sync6	;12
	WAIT11C_A		; +6 delay (if SYNC1)
sync6:
	WAIT4C			; 4
;19c (+-3) == 16 (+6)
	ld	a,12
	dec	a
	jr	nz,$-1
;194c= 12*16+2
	ld	c,5			;raster count 3,4,5,6,7
	inc	de			;6c
	WAIT12C			;12c
;25c
;------------------------------------
;|CgTvŕ␳A1 x 5rasterŌ덷}0.5܂ŕ␳
sync_l:
	in	a,(c)		;CG-ROM
;12c
;----- sync 25.3: sync 250 (+-3)  ----- 
	jr	z,sync2c
	nop				; +1 delay (if SYNC2)
sync2c:
;11.5c (+-0.5)
	ld	a,10
	dec	a
	jr	nz,$-1
;162c= 10*16+2
	ld	de,(15h+1)*256+8	;10 PCG I/O + raster counter
	ld	sp,pcg_wr_sp		;10 PCG branch list
	dec	c					; 4 raster count
	ret	z					; 5 pcg_wr_start / pcg_rd_start
;29c
	WAIT12C
	WAIT12C
	jr	sync_l				;12
;36c
;	in	a,(c)		;CG-ROM
;12c : 48c left

;--------------------------------------
;PCG WRITE : branch entry list
pcg_wr_sp:
	dw	pcg_wr_start	;plane B
	dw	pcg_wr_next		;plane R
	dw	pcg_wr_next		;plane G
	dw	pcg_wr_odd		;plane G
	dw	pcg_wr_next		;plane R
	dw	pcg_wr_next		;plane G
	dw	pcg_wr_end
;--------------------------------------
;PCG`
;CRTC.H-cycle : 250.311142
;
;	WAIT6C
;	WAIT4C
;	jp	sync_l
;	in	a,(c)
;26c left 
;
;	(ret	z)		;(11-5)
;	jp	pcg_wr_loop
;16c : 10c left
;--------------------------------------
;raster loop
;48c left 
pcg_wr_start:
;	(ret	z)		;(11-5)
;6c
	WAIT4C
	WAIT4C
	jr	pcg_wr_loop	;12
;20c : 16c left

;--------------------------------------
;Pv[WX^IÃv[
pcg_wr_next:
;	(ret	z)			;(11-5)
	inc	d				; 4 next plane B->R->G->END
	set	3,e				; 8 E=8 , raster counter
	jp	pcg_wr_loop		;10
;28c
;total      : 250 or 251 clock

;--------------------------------------
;EVEN->ODD : 
pcg_wr_odd:
;|CgSYNC2:SYNC3ɕύX
;	(ret	z)			;(11-5)
	ld	a,0fh					; 7 rrca
	ld	(ic_pcg_wr_sync_op),a	;13
	ld	de,(15h+1)*256+8		;10 PCG I/O + raster counter
;28c +8c ... 8.93968c == 4Lx点ăWC
;--------------------------------------
;raster loop
pcg_wr_loop:
	ld	b,d				;preload
;|CgTvŌ덷PNbNɃL[v
	ld	a,14h
	in	a,(00h)			;SYNC1 and SYNC2
;22c : adjust 37c for SYNC1[L]-SYNC2[0]
;----- syunc----
ic_pcg_wr_sync_op	equ	$
	rlca			;RLCA or RRCA
	jr	nc,$+3
	nop
;15.5c (+-0.5) (SYNC2[1]=15 or SYNC2[0]=16)
	outi		;PCG[0]		;SYNC2 - IOW delay = 27.5c : 12.3 char from SYNC1-2
	ld	b,d
	outi		;PCG[1]
	ld	b,d
	outi		;PCG[2]
	ld	b,d
	outi		;PCG[3]
	ld	b,d
	outi		;PCG[4]
	ld	b,d
	outi		;PCG[5]
	ld	b,d
	outi		;PCG[6]
	ld	b,d
	outi		;PCG[7]
	ld	b,d
	nop
	nop
	nop
	nop
;176c
	dec	e				;raster count
	ret	z				;raster end pcg_wr_next/pcg_wr_odd/pcg_wr_end
;9c
	WAIT7C_A
	WAIT9C_F
	jr	pcg_wr_loop
;28c

;total      : 250 or 251 clock
;-------------------
;AƖߓsv
pcg_wr_end:
;
pcg_ok_join:
	ld	e,0				;error = no_error
;CRTC80ɂǂ
	ld	bc,1801h
	ld	a,80
	out	(c),a			;CRTC.R[1]=80
;--------------------------------------
;VXeX^bNɖ߂
iw_pcgx_spp	equ	$+1
	ld	sp,0

vdisp_error_join:
	push	de			;save error code
;--------------------------------------
;error retry check
	pop	de				;e = error code
	ei
	ld	a,e
	or	a
	jp	nz,pcg_retry	;G[ȂȂ
;--------------------------------------
;PCG\NAďI
;	ld	a,e			;error code
	jp	pcgx_reset

;----------------------------------------------------------
	include	"vram_fill.asm"
;----------------------------------------------------------
;VRAM initialzie data
SYNC1_NUM	equ	19
SYNC2_NUM	equ	 4
SYNC3_NUM	equ	 7
SYNC123_NUM	equ	SYNC1_NUM+SYNC2_NUM+SYNC3_NUM
;
d_fill_blank:
	db	80H +27H,100H-48			;AVRAM
	db	SYNC123_NUM,07H				;SYNC1,2,3 = CG-ROM
	db	80H +37H,100H-48			;TVRAM
	db	SYNC1_NUM,20H				;SYNC1 pattern 000H
	db	SYNC2_NUM,8EH				;SYNC2 pattern 0FEH
	db	SYNC3_NUM,87H				;SYNC3 pattern 0FFH
	db	0							;END
;
d_fill_row0:
	db	80H +27H,100H-18			;AVRAM
PCG_ATTR_BASE	equ	$+1
	db	5,20H			;PCG ATTRIBUTE EVEN
	db	4,20H			;PCG ATTRIBUTE ODD
	db	5,20H			;PCG ATTRIBUTE EVEN
	db	4,20H			;PCG ATTRIBUTE ODD
;2000H
	db	5,20H			;PCG ATTRIBUTE EVEN
	db	4,20H			;PCG ATTRIBUTE ODD
	db	5,20H			;PCG ATTRIBUTE EVEN
	db	4,20H			;PCG ATTRIBUTE ODD
	db	5,20H			;PCG ATTRIBUTE EVEN
	db	4,20H			;PCG ATTRIBUTE ODD
	db	5,20H			;PCG ATTRIBUTE EVEN
	db	4,20H			;PCG ATTRIBUTE ODD
	db	5,20H			;PCG ATTRIBUTE EVEN
	db	4,20H			;PCG ATTRIBUTE ODD
	db	5,20H			;PCG ATTRIBUTE EVEN
	db	4,20H			;PCG ATTRIBUTE ODD
;
	db	80H +37H,100H-18		;TVRAM
PCG_CODE_BASE	equ	$+1
	db	5,00H			;PCG CODE EVEN
	db	4,27H			;PCG CODE ODD
	db	5,00H			;PCG CODE EVEN
	db	4,27H			;PCG CODE ODD
;3000H
	db	5,00H			;PCG CODE EVEN
	db	4,27H			;PCG CODE ODD
	db	5,00H			;PCG CODE EVEN
	db	4,27H			;PCG CODE ODD
	db	5,00H			;PCG CODE EVEN
	db	4,27H			;PCG CODE ODD
	db	5,00H			;PCG CODE EVEN
	db	4,27H			;PCG CODE ODD
	db	5,00H			;PCG CODE EVEN
	db	4,27H			;PCG CODE ODD
	db	5,00H			;PCG CODE EVEN
	db	4,27H			;PCG CODE ODD
	db	0				;END

;----------------------------------------------------------
;ꎞobt@GAAPCG`鎞KvɂȂ܂B
;ɔzuĂOKłB
b_pcg_book_left:	;number of book left
	ds	1
b_pattern:
	ds	NUM_PCG_CHR/2*8*3	;PCG pattern buffer
b_pattern_odd:
	ds	NUM_PCG_CHR/2*8*3	;PCG pattern buffer
