;----------------------------------------------------------
;PCG`f[^̗\iC^[XXLj
;in
;	E   : PCG charactor code
;	HL  : pattern data
;out
;	CF  : 0=OK , 1=BUFFER FULL
;	HL  : next pattern data (+18H)
;note:
;	data layout
;	pattern[+00H] : plane B,raster 0
;	pattern[+01H] : plane B,raster 1
;	pattern[+08H] : plane R,raster 0
;	pattern[+10H] : plane G,raster 0
;	pattern[+17H] : plane G,raster 7
;
;----------------------------------------------------------
pcgx_data_set:
;\ɋ󂫂邩mF
	ld	a,(b_pcg_book_left)
	sub	1					;1炷 , CF = 󂫂Ȃ
	ret	c					;CF=1 buffer full
	ld	(b_pcg_book_left),a
;
	push	af
	push	hl
	cp	NUM_PCG_CHR-1		;ŏH
	ld	b,1					;1
	jr	c,pcg_book_l
	ld	b,NUM_PCG_CHR		;SẴGAɏ
pcg_book_l:
;HL = PCG_PCG_BASE+(APOS*2)
	add	a,a
	add	low PCG_CODE_BASE
	ld	l,a
	adc	a,high PCG_CODE_BASE
	sub	l
	ld	h,a
	ld	(hl),e				;PCG Code
	dec	hl
	dec	hl
	djnz	pcg_book_l
	pop	hl			;pattern
	pop	af			;apos
 if PCG_LAYOUT_INTERACE
;f[^z : 0,2,4,8,10,12,14, 1,3,5,7,9,11,13,15
;DE = PCG_ATTR_BASE +(APOS/2) +(APOS&1)*(NUM_PCG_CHR/2)
	ld	de,b_pattern		;͑O
	srl	a
	jr	nc,$+5
	ld	de,b_pattern_odd	;͌㔼
	add	a,e
	ld	e,a
	adc	a,d
	sub	e
	ld	d,a
 else
;DE = PCG_ATTR_BASE +(APOS)
	add	a,low b_pattern
	ld	e,a
	adc	a,high b_pattern
	sub	e
	ld	d,a
 endif
;store pattern data
	ld	bc,3*8*256 +255			;one char B[8]+R[8]+G[8],dummy count
pcg_pattern_set_l:
	ldi
;DE += NUM_PCG_CHR
	ld	a,e
 if PCG_LAYOUT_INTERACE
	add	a,NUM_PCG_CHR/2-1
 else
	add	a,NUM_PCG_CHR-1
 endif
	ld	e,a
	jr	nc,$+3
	inc	d
	djnz	pcg_pattern_set_l
	xor	a
	ret
