;----------------------------------------------------------
;Title   : \܂ 27{PCG` for SHARP X1
;Version : Ver.2019.10.11
;Auther  : @superturboZ
;	
;usage:
;	call	pcgx_setup    : PCGhCopɃeLXgVRAMB
;	call	pcgx_set_data : PCG`f[^\񂷂BiWȉj
;	call	pcgx_update   : \񂵂PCG`sB
;
;spec:
;
;SYNC1ƃR[hl߂ĂPsX`ł悤ɂ
;悭u`邽߃X^bNpAR[hʂƕKvobt@
;
;note:
;
;CRTC/PCG ^C~O
;     : 4.0 / (14.31818 /8)   = 2.23492 CPU clks per CRTC char
;`Ԋu : INC B OUTI            = 20 clks , *2.23492 = 8.9488 char
;`   : (IOW.T2R-T4F)         = 2.5clks , *2.23492 = 1.1161 char
;
;PCG`peLXgVRAM zu
;|SYNC1|SYNC2|PCG0|PCG0||PCG 1..7  |N.U.||total|
;| 19  | 11  |  9 |  9 || 9 x7 =63 |  1 || 112 |
;| 48 (37D0-37FF)    9 ||64(3000-303F)  || 112 |
;
;V[PX
;SETUP
;@E擪64oCgA/TVRAMۑ
;@EuNGAA/TVRAMݒ
;UPDATE
;@EVDISP ҂
;ROW 0..23
;@Ei\ʒuQsڈȍ~ɂȂ܂ő҂j
;ROW 1..24
;@E擪64oCgA/TVRAMPCGpɐݒ
;@EVBLANK ҂AVBLANK˓Ȃ璆făgC
;ROW 25 : 
;@ECRTC̕\0ɐݒ
;@ESYNCCG-ROM[hg +-0.5 char xɓ
;ROW 26 : PCG.B ` CHR[0..8] x RASTER[0..7]
;ROW 27 : PCG.R ` CHR[0..8] x RASTER[0..7]
;ROW 28 : PCG.G ` CHR[0..8] x RASTER[0..7]
;ROW 29,30,31,32(2 raster)
;@ECRTC̕\80ɖ߂B
;@E擪64oCgA/TVRAM𕜌

;----------------------------------------------------------
;}NƂ
;----------------------------------------------------------

NUM_PCG_CHR			equ	9	;Pt[Œ`łő吔AύXsB
PCG_LAYOUT_INTERACE	equ	0	;f[^z

;----------------------------------------------------------
	include	"wait.mac"

;----------------------------------------------------------
	include	"pcgx_setup.asm"
	include	"pcgx_data_set.asm"
;----------------------------------------------------------

;----------------------------------------------------------
;PCG̒`s
;pcgx_data_set ŗ\񂵂PCG`܂
;
;in:
;out:
;	A : error code
;
;----------------------------------------------------------
pcgx_update:
;--------------------
pcg_retry:
;VDISPJn҂
vdisp_wait_l:
	ei
	ld	bc,1a01h
	nop
	di
	in	a,(c)
	jp	p,vdisp_wait_l
;Psڂ̕\mɔ邽߁APs̎Ԃ҂
	ld	a,125
	dec	a
	jr	nz,$-1
;Psڂ̕\͏IĂ̂ŁAPsڂVRAMPCGpɃZbgAbv
	ld	hl,d_fill_row0
	call	vram_fill
;setup OK
	ld	hl,b_pattern		;PCG pattern buffer
;sace system stack
	ld	(iw_pcgx_spp),sp
;VDISPă`FbN
	ld	bc,1a01h
	ld	e,1					;error code
	in	a,(c)				;VDISP
	jp	p,vdisp_error_join		;łVBLANK˓Ȃ烊gC
;VBLANK҂
vblank_wait_l:
	in	a,(c)				;-VBLANK
	jp	m,vblank_wait_l
;---- sync 25.0 ----
;10c (+22)
;CRTCOɐݒ
	ld	bc,1800h	;10
	ld	de,1*256 +0	;10
	out	(c),d		;12
	inc	c			; 4
	out	(c),e		;12 CRTC.R[1]=0
;48c
	ld	bc,1400h	;10 CG-ROM I/O
	ld	e,7			; 7 raster loop
;17c
	ld	a,9			; 7 wc 	
	dec	a
	jr	nz,$-1
;146c = 9*16+2
	ld	a,(hl)
	WAIT12C
;19c

;VBLANK  X1F/X1tZ@ł0.1-1.1L炢̒xŌoł炵B
;PCG-RAMpCvC̒xlĂQLȏVBALNKωQLxĎ荞ނ̂S
;250+4 -12(IN) = 242cœƍl΂悵H

;SYNC1̐͏\̂ŁAƒx点SȁB
	WAIT4C
	
;------------------------------------
;PX^SYNC1/SYNC2̃{[_[CG-ROMp^[ŕ߂܂B
;덷 -0+22 == }11 clock
sync22:
	in	a,(c)		;CG-ROM
;12c
;---- sync 25.1 : 254c (+22c) -----
	jp	p,sync22
;21c (+-11) == 10c+22c
	ld	a,12
	dec	a
	jr	nz,$-1
;194c = 12*16+2
	ld	a,(hl)
	WAIT12C
	WAIT4C
;23c
;|CgTvŌ덷𔼕́}6 clock ɕ␳
	in	a,(c)		;CG-ROM
;12c
;----- sync 25.2 : 250c (+-11c) -----
	jr	nz,sync6	;12
	WAIT11C_A		; +6 delay (if SYNC1)
sync6:
	WAIT4C			; 4
;19c (+-3) == 16 (+6)
	ld	a,12
	dec	a
	jr	nz,$-1
;194c= 12*16+2
	ld	c,5			;raster count 3,4,5,6,7
	inc	de			;6c
	WAIT12C			;12c
;25c
;------------------------------------
;|CgTvŕ␳A2clock x 5rasterŌ덷}Pɕ␳
sync_l:
	in	a,(c)		;CG-ROM
;12c
;----- sync 25.3: sync 250 (+-3)  ----- 
	jr	nz,sync2c
	WAIT7C_A		; +2 delay (if SYNC1)
sync2c:
	ld	a,10
	dec	a
	jr	nz,$-1
;162c= 10*16+2
	ld	de,(15h+1)*256+8	;10 PCG I/O + raster counter
	ld	sp,pcg_wr_sp		;10 PCG branch list
	dec	c					; 4 raster count
	ret	z					; 5 pcg_wr_start / pcg_rd_start
;29c
	WAIT12C
	WAIT12C
	jr	sync_l				;12
;36c
;	in	a,(c)		;CG-ROM
;12c : 48c left

 if 0  ;͓܂
;--------------------------------------
;PCG READ : branch entry list
pcg_wr_sp:
	dw	pcg_rd_start	;plane B
	dw	pcg_rd_next		;plane R
	dw	pcg_rd_next		;plane G
	dw	pcg_rd_end

;--------------------------------------
;CG/PCG[h
pcg_rd_start:
;--------------------------------------
pcg_rd_loop:
	dec	d				;adjust OUTI to INI and IOR-MEMW timming
;|CgTvŌ덷PNbNɃL[v
	ld	a,14h
	in	a,(00h)			;SYNC1 and SYNC2
;22c
;----- raster 0: sync 250 (+-n) -----
	rlca
	jr	nc,$+3
	nop
;15.5c (+-0.5) : 15(SYNC2) / 16(SYNC1)
	ld	b,d				;preload & adjust  IOR-MEMW timming
	ini					;(13c , delay 28.5c -> 12.75 char from SYNC1-2
	ld	b,d
	ini
	ld	b,d
	ini
	ld	b,d
	ini
	ld	b,d
	ini
	ld	b,d
	ini
	ld	b,d
	ini
	ld	b,d
	ini
;160c
	inc	d				;adjust INI to OUTI
	dec	e				;raster count
	jr	z,pcg_rd_next	;raster end
;15c / 20c
	WAIT12C
	WAIT14C_A			
	jr	pcg_rd_loop		;12
;38c
;total        : 250.5 (+-0.5)
;-------------------
;̃v[
pcg_rd_next:
;	(jr)				;+5
	set	3,e				; 8 E=8,reload raster counter
	inc	d				; 4 B -> R -> G -> END
	ld	a,d				; 4
IB_PCG_RD_END_PLANE	equ	$+1
	cp	17h+1+1			; 7
	jp	c,pcg_rd_loop	;10
;38c
;-------------------
	jr	pcg_ok_join
 endif

;--------------------------------------
;PCG WRITE : branch entry list
pcg_wr_sp:
	dw	pcg_wr_start	;plane B
	dw	pcg_wr_next		;plane R
	dw	pcg_wr_next		;plane G
;	dw	pcg_verify		;readback
	dw	pcg_wr_end
;--------------------------------------
;PCG`
;CRTC.H-cycle : 250.311142
;
;	WAIT6C
;	WAIT4C
;	jp	sync_l
;	in	a,(c)
;26c left 
;
;	(ret	z)		;(11-5)
;	jp	pcg_wr_loop
;16c : 10c left
;--------------------------------------
;raster loop
;48c left 
pcg_wr_start:
;	(ret	z)		;(11-5)
;6c
	WAIT4C
	WAIT4C
	jr	pcg_wr_loop	;12
;20c : 16c left

;--------------------------------------
;Pv[WX^IÃv[
pcg_wr_next:
;	(ret	z)			;(11-5)
	inc	d				; 4 next plane B->R->G->END
	ld	e,8				; 7 raster counter
	WAIT11C_A			;11
;28c
;total      : 250 or 251 clock

;--------------------------------------
;raster loop
pcg_wr_loop:
	ld	b,d				;preload
;|CgTvŌ덷PNbNɃL[v
	ld	a,14h
	in	a,(00h)			;SYNC1 and SYNC2
;22c : adjust 37c for SYNC1[L]-SYNC2[0]
;----- syunc----
	rlca
	jr	nc,$+3
	nop
;15.5c (+-0.5) (SYNC2[1]=15 or SYNC2[0]=16)
	outi		;PCG[0]		;SYNC2 - IOW delay = 27.5c : 12.3 char from SYNC1-2
	ld	b,d
	outi		;PCG[1]
	ld	b,d
	outi		;PCG[2]
	ld	b,d
	outi		;PCG[3]
	ld	b,d
	outi		;PCG[4]
	ld	b,d
	outi		;PCG[5]
	ld	b,d
	outi		;PCG[6]
	ld	b,d
	outi		;PCG[7]
	ld	b,d
	outi		;PCG[8]
;176c
	dec	e				;raster count
	ret	z				;raster end
;9c
	WAIT7C_A
	WAIT9C_F
	jr	pcg_wr_loop
;28c

;total      : 250 or 251 clock
;-------------------
;AƖߓsv
pcg_wr_end:
;
pcg_ok_join:
	ld	e,0				;error = no_error
;CRTC80ɂǂ
	ld	bc,1801h
	ld	a,80
	out	(c),a			;CRTC.R[1]=80
;--------------------------------------
;VXeX^bNɖ߂
iw_pcgx_spp	equ	$+1
	ld	sp,0
vdisp_error_join:
	push	de			;save error code
;VBLANKɐ擪s̃eLXgVRAM𕜌
	ld	bc,2000h
	ld	hl,b_avram_save
	call	outi_64
;40x64 = 2560c
	ld	bc,3000h
	call	outi_64
;40x64 = 2560c
;--------------------------------------
;error retry check
	pop	de				;e = error code
	ei
	ld	a,e
	or	a
	jp	nz,pcg_retry	;G[ȂȂ
;--------------------------------------
;PCG\NAďI
;	ld	a,e			;error code
	jp	pcgx_reset

;----------------------------------------------------------
outi_64:
	ld	e,64
;	jp	outi_e
	include	"outi_e.asm"
;----------------------------------------------------------
ini_64:
	ld	e,64
;	jp	ini_e
	include	"ini_e.asm"
;----------------------------------------------------------
	include	"vram_fill.asm"
;----------------------------------------------------------
;VRAM initialzie data
SYNC1_NUM	equ	19
SYNC2_NUM	equ	11

d_fill_blank:
	db	80H +27H,100H-48			;AVRAM
	db	SYNC1_NUM+SYNC2_NUM,00H		;SYNC1+SYNC2 = CG-ROM
	db	80H +37H,100H-48			;TVRAM
	db	SYNC1_NUM,20H				;SYNC1 pattern 000H
	db	SYNC2_NUM,87H				;SYNC2 pattern 0FFH
	db	0							;END
;
d_fill_row0:
	db	80H +27H,100H-18			;AVRAM
	db	9,20H			;PCG0 ATTRIBUTE
	db	9,20H			;PCG1 ATTRIBUTE
;2000H
	db	9,20H			;PCG2 ATTRIBUTE
	db	9,20H			;PCG3 ATTRIBUTE
	db	9,20H			;PCG4 ATTRIBUTE
	db	9,20H			;PCG5 ATTRIBUTE
	db	9,20H			;PCG6 ATTRIBUTE
	db	9,20H			;PCG7 ATTROBUTE
	db	9,20H			;PCG8 ATTROBUTE
;
	db	80H +37H,100H-18		;TVRAM
PCG_CODE_BASE	equ	$+1
	db	9,00H			;PCG0 CODE
	db	9,00H			;PCG1 CODE
;3000H
	db	9,00H			;PCG2 CODE
	db	9,00H			;PCG3 CODE
	db	9,00H			;PCG4 CODE
	db	9,00H			;PCG5 CODE
	db	9,00H			;PCG6 CODE
	db	9,00H			;PCG7 CODE
	db	9,00H			;PCG8 CODE
	db	0				;END

;----------------------------------------------------------
;ꎞobt@GAAPCG`鎞KvɂȂ܂B
;ɔzuĂOKłB
b_pcg_book_left:	;number of book left
	ds	1
b_pattern:
	ds	NUM_PCG_CHR*8*3	;PCG pattern buffer
b_avram_save:
	ds	64		;AVRAM save buffer
;b_tvram_save:
	ds	64		;TVRAM save buffer
